if(isfile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	RTB_registerPref("Toggle","Brick Limits","BrickLimits::Toggle","bool","Server_BrickLimits",0,0,0);
	RTB_registerPref("Donate","Brick Limits","BrickLimits::Donate","bool","Server_BrickLimits",0,0,0);
	RTB_registerPref("Display Bar","Brick Limits","BrickLimits::DisplayBar","bool","Server_BrickLimits",0,0,0);
	RTB_registerPref("Starting Brick Limit","Brick Limits","BrickLimits::Limit","int 0 256000","Server_BrickLimits",50,0,1);
	RTB_registerPref("Increase (Bricks)","Brick Limits","BrickLimits::LimitIncrease","int 0 256000","Server_BrickLimits",50,0,0);
	RTB_registerPref("Time (secs)","Brick Limits","BrickLimits::Time","int 0 86400","Server_BrickLimits",600,0,0);
	
	
}
else
{
	$BrickLimits::Toggle = 0;
	$BrickLimits::Donate = 0;
	$BrickLimits::DisplayBar = 0;
	$BrickLimits::Limit = 50;
	$BrickLimits::LimitIncrease = 50;
	$BrickLimits::Time = 600;
}

$BL::Started = 0;

package BrickLimits
{
	function serverCmdPlantBrick(%client)
	{
		if($BrickLimits::Toggle)
		{
			%bricklimit = %client.currbricklimit;
			if(isObject(%client.player.tempbrick))
				%bricks = %client.brickgroup.getcount() - 1;
			else
				%bricks = %client.brickgroup.getCount();
			if(%bricks >= %bricklimit)
			{
				commandtoclient(%client,'centerprint',"\c6You have used up all your bricks for now",2);
				return;
			}
		}
		Parent::serverCmdPlantBrick(%client);
	}

	function GameConnection::AutoAdminCheck(%client)
	{
		%client.currbricklimit = $BrickLimits::Limit;
		Parent::AutoAdminCheck(%client);
	}
	
	function BrickAddTick()
	{
		cancel($BrickAddTick);
		if($BrickLimits::Toggle)
			AddToBrickLimit();
		$BrickAddTick = schedule($BrickLimits::Time*1000,0,BrickAddTick);
	}

	function AddToBrickLimit()
	{
		if(!$BL::Started)
		{
			$BL::Started = 1;
			schedule($BrickLimits::Time*1000,0,BrickAddTick);
			return;
		}
		if($BrickLimits::Toggle)
		{
			if($BrickLimits::LimitIncrease > 0)
			{
				for(%i=0;%i<clientGroup.getCount();%i++)
				{
					%client = clientGroup.getObject(%i);
					%current = %client.currbricklimit;
					%new = %current + $BrickLimits::LimitIncrease;
					%client.currbricklimit = %new;
					MessageClient(%client,'',"\c6You have been given \c3" @ $BrickLimits::LimitIncrease @ " \c6bricks.");
				}
			}
		}
	}
	
	function BrickLimitDisplayBar()
	{
		cancel($BLDBTick);
		if($BrickLimits::Toggle)
		{
			if($BrickLimits::DisplayBar)
			{
				for(%i=0;%i<clientGroup.getCount();%i++)
				{
					%client = clientGroup.getObject(%i);
					if(%client.currbricklimit >= 256000)
						%bricks = "Unlimited";
					else
						%bricks = %client.currbricklimit;
					if(isObject(%client.player.tempbrick))
						%ub = %client.brickgroup.getcount() - 1;
					else
						%ub = %client.brickgroup.getcount();
					commandtoclient(%client,'bottomprint',"\c3Brick Limit:  \c6"@%ub@"\c3/\c6"@%bricks@" \n\c6Type \c3/bricklimithelp \c6for more info","",1);
				}
			}
		}
		$BLDBTick = schedule(100,0,BrickLimitDisplayBar);
	}

	function RemoveBrickLimitDisplayBar()
	{
		cancel($SBLDBTick);
		if(!$BrickLimits::DisplayBar)
		{
			for(%i=0;%i<clientGroup.getCount();%i++)
			{
				%client = clientGroup.getObject(%i);
				commandtoclient(%client,'bottomprint',"",1,1);
			}
		}
		$SBLDBTick = schedule(100,0,RemoveBrickLimitDisplayBar);
	}

	function servercmdgivebricks(%client,%name,%value)
	{
		if($BrickLimits::Toggle)
		{
			if(%client.isAdmin)
			{
				%target = findclientbyname(%name);
				if(!isObject(%target))
				{
					MessageClient(%client,'',"\c6Unable to find target");
					return;
				}
				if(%value * 1 == %value)
				{
					if(%value > 0)
					{
						%current = %target.currbricklimit;
						%new = %current + %value;
						%target.currbricklimit = %new;
						MessageAll('',"\c3" @ %client.name SPC "\c6has given\c3" SPC %target.name SPC "\c6" SPC %value SPC "bricks");
					}
					else
						MessageClient(%client,'',"\c6You must enter a value greater than 0");
				}
				else
					MessageClient(%client,'',"You have entered an invalid value");
			}	
		}
	}
	
	function servercmdremovebricks(%client,%name,%value)
	{
		if($BrickLimits::Toggle)
		{
			if(%client.isAdmin)
			{
				%target = findclientbyname(%name);
				if(!isObject(%target))
				{
					MessageClient(%client,'',"\c6Unable to find target");
					return;
				}
				if(%value * 1 == %value)
				{
					if(%value > 0)
					{
						%current = %target.currbricklimit;
						if(%val > %current)
						{
							MessageClient(%client,'',"You have entered a value which is too high");
							return;
						}
						%new = %current - %value;
						%target.currbricklimit = %new;
						MessageAll('',"\c3" @ %client.name SPC "\c6has removed" SPC %value SPC "bricks from\c3" SPC %target.name);
					}
						MessageClient(%client,'',"\c6You must enter a value greater than 0");
				}
				else
					MessageClient(%client,'',"You have entered an invalid value");
			}
		}
	}
	
	function servercmdmybricks(%client)
	{
		if($BrickLimits::Toggle)
		%bricks = %client.currbricklimit;
		if(%bricks $= "")
			%bricks = 0;
		MessageClient(%client,'',"\c6You have \c3" @ %bricks SPC "\c6bricks");
	}
	
	function servercmdgetbricks(%client,%name)
	{
		if($BrickLimits::Toggle)
		%target = findclientbyname(%name);
		if(isObject(%target))
		{
			%bricks = %target.currbricklimit;
			if(%bricks $= "")
				%bricks = 0;	
			MessageClient(%client,'',"\c3" @ %target.name SPC "\c6has\c3" SPC %bricks SPC "\c6bricks");
		}
	}

	function servercmdresetbricklimits(%client)
	{
		if(%client.isAdmin)
		{
			for(%i=0;%i<clientGroup.getCount();%i++)
			{
				%cl = clientGroup.getObject(%i);
				%cl.currbricklimit = $BrickLimits::Limit;
			}
			MessageAll('',"\c3"@%client.name@" \c6has reset all brick limits.");
		}
	}

	function servercmdsetbricks(%client,%name,%value)
	{
		if($BrickLimits::Toggle)
		{
			if(%client.isAdmin)
			{
				%target = findclientbyname(%name);
				if(isObject(%target))
				{
					if(%value*1 == %value)
					{
						%target.currbricklimit = %value;
						MessageAll('',"\c3"@%client.name SPC "\c6has set\c3" SPC %target.name SPC "\c6brick limit to" SPC %value);
					}
				}
				else
					MessageClient(%client,'',"\c6Unable to find target");
			}
		}
	}

	function servercmddonatebricks(%client,%name,%value)
	{
		if($BrickLimits::Toggle)
		{
			if($BrickLimits::Donate)
			{
				%target = findclientbyname(%name);
				if(isObject(%target))
				{
					if(%client.bl_id == %target.bl_id)
					{
						MessageClient(%client,'',"\c6You cannot donate to yourself");
						return;
					}
					if(%value*1 == %value)
					{
						if(%value > 0)
						{
							%current = %client.currbricklimit;
							if(%value <= %current)
							{
								%newclient = %current - %value;
								%client.currbricklimit = %newclient;
								%targetcurrent = %target.currbricklimit;
								%newtarget = %targetcurrent + %value;
								%target.currbricklimit = %newtarget;
								MessageClient(%client,'',"\c6You have donated " @ %value SPC "bricks to\c3" SPC %target.name);
								MessageClient(%target,'',"\c3"@%client.name SPC "\c6has donated you" SPC %value SPC"bricks");
							}
							else
								MessageClient(%client,'',"You cannot donate that many bricks");
						}
						else
							MessageClient(%client,'',"\c6You must donate a value more than 0");
					}
					else
						MessageClient(%client,'',"\c6You have entered an invalid value");
				}
				else
					MessageClient(%client,'',"\c6Unable to find target");
			}
		}
	}
	
	function servercmdbricklimithelp(%client)
	{
		MessageClient(%client,'',"\c6This server has a set brick limit for each person");
		if($BrickLimits::LimitIncrease > 0)
			MessageClient(%client,'',"\c6Over a period of time you will recieve \c3"@$BrickLimits::LimitIncrease@" \c6more bricks");
		MessageClient(%client,'',"\c6Type \c3/mybricks \c6to see how many bricks you have");
		MessageClient(%client,'',"\c6Type \c3/donatebricks (name) (value) \c6to donate bricks to another player");
		if(%client.isAdmin)
		{
			MessageClient(%client,'',"\c5Admins can use the following commands");
			MessageClient(%client,'',"\c6Type \c3/getbricks (name) \c6to see how many bricks a player has");
			MessageClient(%client,'',"\c6Type \c3/givebricks (name) (value) \c6to give players bricks");
			MessageClient(%client,'',"\c6Type \c3/setbricks (name) (value) \c6to set a players bricks");
			MessageClient(%client,'',"\c6Type \c3/removebricks (name) (value) \c6to remove players bricks");
			MessageClient(%client,'',"\c6Type \c3/resertbricklimits \c6to reset all player brick limits");
		}
	}
};
activatepackage(BrickLimits);
BrickAddTick();
BrickLimitDisplayBar();
RemoveBrickLimitDisplayBar();

			
		
	
	